﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class ChurchShopButton : MonoBehaviour {

    public PlayerStats stats; // to add potions to inventory
    public int potionNumber;
    public Text potionName;
    public Text description;
    public Text cost;
    public Text inInventory;
    public Image imageDisplay;
    private PotionObject[] potions; // to get access to the potion array
    public Money money; // to access and manipulate coin amount
    private int price;
    public Button shopButton; // to access button colours
    private ColorBlock block;
    private int currentAmount;

    // ** BUTTON NAVIGATION IS SET TO NONE - WILL HAVE TO TWEAK IF WE DECIDE ON CONTROLLER IMPLEMENTATION

    void Start () {
        stats = GameObject.Find("ShopPlayer").GetComponent<PlayerStats>();
        potions = GameObject.Find("Canvas").GetComponent<PotionList>().potions;
        price = potions[potionNumber].cost;
        block = new ColorBlock();
        block = shopButton.colors;
        setButton();
    }

    void Update() {
        if (money.getMoney() >= price) {
            block.pressedColor = Color.gray;
            shopButton.colors = block;
        }
        else {
            block.pressedColor = Color.red; // can't afford = red click
            shopButton.colors = block;
        }
    }

    // created by following the 'Creating An In-Game Shop' shop tutorial on unity3d.com
    // dynamically allocates the shop buttons based on created weapons
    void setButton() {
        string costToString = potions[potionNumber].cost.ToString(); // convert float to string
        potionName.text = potions[potionNumber].potionName;
        description.text = potions[potionNumber].potionDescription;
        cost.text = costToString;
        imageDisplay.sprite = potions[potionNumber].image;
        

        if (potionName.text == "Health Potion") {
            inInventory.text = stats.getHealthPot().ToString();
            currentAmount = int.Parse(inInventory.text);
        }
        else if (potionName.text == "Strength Potion") {
            inInventory.text = stats.getStrengthPot().ToString();
            currentAmount = int.Parse(inInventory.text);
        }
        else if (potionName.text == "Defense Potion") {
            inInventory.text = stats.getDefensePot().ToString();
            currentAmount = int.Parse(inInventory.text);
        }
        else if (potionName.text == "Agility Potion") {
            inInventory.text = stats.getAgilityPot().ToString();
            currentAmount = int.Parse(inInventory.text);
        }

        if (currentAmount >= 5) {
            inInventory.color = Color.green;
        }
        else {
            inInventory.color = Color.grey;
        }
    }

    public void OnClick() {
        // buying potions based on currency
        if (money.getMoney() >= price) {
            if (currentAmount < 5) { // potion cap of 5
                money.decreaseCoins(price);

                if (potionName.text == "Health Potion") {
                    stats.addHealthPot(1);
                }
                else if (potionName.text == "Strength Potion") {
                    stats.addStrengthPot(1);
                }
                else if (potionName.text == "Defense Potion") {
                    stats.addDefensePot(1);
                }
                else if (potionName.text == "Agility Potion") {
                    stats.addAgilityPot(1);
                }
                setButton();
            }
        }
        else {
            // will implement sound that the player cannot afford here. (visual handled in update)
        }
    }
}